Unit ASK6C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AR01C_p, AR02C_p, ASK3C_p;

procedure ASK6C(var A :Array of Complex; var X :Array of Complex;
                var R :Array of Complex; M :Integer; L :Integer;
                K :Integer);

implementation

procedure ASK6C(var A :Array of Complex; var X :Array of Complex;
                var R :Array of Complex; M :Integer; L :Integer;
                K :Integer);
var
I,J,MA,ML,MX,M1 :Integer;
PII,RK :Real;
const
SYS003 :Real = 6.2831853071795864769252867665590;
label
_1,_2;
begin

{  ****************************************************************** C }
{                                                                     C }
{  ------------------------  HAHAEHE  ---------------------------- C }
{                                                                     C }
{       PEEHE CCTEM HEHX AEPAECKX YPABHEH  A X = B    C }
{       C KETOHO-PKYHTHO MATPE , BCE KETK KOTOPO CYT    C }
{       KETOHO - PKYHTHE MATP C KETKAM OEO BA        C }
{       ( T.E. A - TPEXYPOBHEBA MATPA  CCG-TA ) .                C }
{                                                                     C }
{       OPOHOE OCAHE :                                          C }
{       ( 1 ) E.E.TPTHKOB , O PEEH CCTEM C MATPAM TA     C }
{       TEEBX , B C. CEHH AHA HA OPTPAHE               C }
{       ( BCTEHE METO  HCTPYMEHTAHE CCTEM ) ,        C }
{       -BO MY , 1978 .                                           C }
{                                                                     C }
{                                                                     C }
{  ---------------------------  METO  ------------------------------ C }
{                                                                     C }
{       MATPA  A  KETOHOO PAMEPA  K * K , C KETKAM PAMEPA    C }
{       (M*L) * (M*L) , OOHM PEOPAOBAHEM PBOTC K         C }
{       KETOHO - AOHAHO MATPE TEX E PAMEPOB . TEM CAMM   C }
{       PEEHE CXOHO CCTEM C TPEXYPOBHEBO MATPE  CCG-TA   C }
{       ( OPKA  M*L*K ) CBEEHO K PEEH   K   CCTEM C BYX-     C }
{       YPOBHEBM MATPAM CG-TA ( OPKA  M*L ) .               C }
{                                                                     C }
{                                                                     C }
{  ------------------  K  POPAMMPOBAH  ---------------------- C }
{                                                                     C }
{       OPTPAH                                                       C }
{                                                                     C }
{                                                                     C }
{  -----------------  OPAHA - PAPAOTK  -------------------- C }
{                                                                     C }
{       HAYHO - CCEOBATECK BCTEH EHTP  M  Y ,      C }
{       AOPATOP  CEHHOO  AHAA                              C }
{                                                                     C }
{       APEC :                                                       C }
{       MOCKBA ,117234 , HB MY , AOPATOP CEHHOO AHAA    C }
{                                                                     C }
{  -----------------------  COOBAHE  -------------------------- C }
{                                                                     C }
{       CALL ASK6C(A,X,R,M,L,K)                                       C }
{                                                                     C }
{  -------------------------  APAMETP  ---------------------------- C }
{                                                                     C }
{       A - KOMEKCH OHOMEPH MACCB H  M * M * L * K ,      C }
{           B KOTOPOM AAETC MATPA CCTEM COACHO PABAM ,    C }
{           AHHM B ( 1 ) . A MEHHO : MACCB  A  ETC HA   K     C }
{           KYCKOB H  M * M * L . B I-OM KYCKE AAETC KETKA    C }
{           1 - O YPOBH , BAC I-O KETKO EPBO KETOHO  C }
{           CTPOK CXOHO MATP. AAHE I-O KETK 1-O YPOBH  C }
{           B CBOEM KYCKE OCYECTBETC CEYM OPAOM :          C }
{           COOTBETCTBY KYCOK ETC HA  L  CEMEHTOB H      C }
{           M * M . B J-OM CEMEHTE , J = 1,...,M , ACBAETC      C }
{           KETKA 2-O YPOBH, BAC J-O KETKO EPBO        C }
{           KETOHO CTPOK I-O KETK . BCE KETK 2-O YPOBH B   C }
{           CBOX CEMEHTAX ACBATC O CTOAM .                C }
{                                                                     C }
{       X - KOMEKCH OHOMEPH MACCB H  M*L*K , B KOTOPOM    C }
{           AAETC PABA ACT . HA BXOE OPOPAMM B  X       C }
{           OYAETC PEEHE .                                      C }
{                                                                     C }
{       R - KOMEKCH OHOMEPH PAO MACCB H MAX(Q,M,L),   C }
{           E  Q - EA ACT CA  ( M+1 ) / 2  .                C }
{                                                                     C }
{       M - OPOK 3 - O YPOBH . T : E.                      C }
{                                                                     C }
{       L - OPOK 2 - O YPOBH . T : E.                      C }
{                                                                     C }
{       K - OPOK 1 - O YPOBH . T : E.                      C }
{                                                                     C }
{                                                                     C }
{  -----------------  BBAEME  OPOPAMM  --------------------- C }
{                                                                     C }
{       AR01C , AR02C , ASK3C , ASG1C .                               C }
{                                                                     C }
{  ****************************************************************** C }
{                                                                     C }
{                                                                     C }
{                                                                     C }
{                                                                     C }
{  -------------------------  KOHCTAHT  ---------------------------- C }

{       SYS003=6.2831853717958647692528 ( 2 *  ) }


PII := SYS003/K;
ML := M*L;
MX := ML*K;
M1 := M*ML;
MA := M1*K;

AR01C(A,R,M1,K,PII);
AR02C(X,R,ML,K,PII);

J := 1;
I := 1;
while ( I<=MA ) do
 begin
  ASK3C(A[I-1],X[J-1],R,M,L);
_1:
  J := J+ML;
  inc(I,M1);
 end;

AR01C(X,R,ML,K,PII);

RK := 1.0/K;
for I:=1 to MX do
 begin
_2:
  X[I-1] := MulC(X[I-1],Cmplx(RK,0.0));
 end;

end;

end.
